Skip to main content
`Ctrl`+`K`

# DMShellSetRefine

Set the routine used to refine the `DMSHELL`

## Synopsis

    #include "petscdmshell.h"
    PetscErrorCode DMShellSetRefine(DM dm, PetscErrorCode (*refine)(DM, MPI_Comm, DM *))

Logically Collective

## Input Parameters

- dm - the `DMSHELL`

- refine - the routine that refines the `DM`

## See Also

`DM`, `DMSHELL`, `DMShellSetCoarsen()`, `DMRefine()`, `DMShellGetRefine()`, `DMShellSetContext()`, `DMShellGetContext()`

## Level

advanced

## Location

src/dm/impls/shell/dmshell.c

## Examples

src/ksp/ksp/tutorials/ex65.c

Index of all DM routines
Table of Contents for all manual pages
Index of all manual pages